/***
 * Juliac
 * Copyright (C) 2008-2012 Inria, Univ. Lille 1
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: fractal@ow2.org
 *
 * Author: Lionel Seinturier
 */

package org.objectweb.fractal.juliac.api;

import java.io.File;
import java.io.IOException;
import java.util.List;

import org.objectweb.fractal.juliac.SourceFile;

/**
 * This interface describes the compilation service used by Juliac.
 * 
 * @author Lionel Seinturier <Lionel.Seinturier@univ-lille1.fr>
 */
public interface CompileSupportItf extends JuliacModuleItf {

    /**
     * Compile the specified source files and dump the resulting bytecode files
     * into the specified directory.
     * 
     * @param sfs       the source files
     * @param classDir  the directory for storing bytecode files
     * @return 
     * 		the paths relative to <code>classDir</code> of compiled bytecode
     * 		files 
     * @throws IOException  if an error occurs during the compilation
     */
    public List<String> compile( List<SourceFile> sfs, File classDir )
    throws IOException;
}
