/***
 * Juliac
 * Copyright (C) 2011-2012 Inria, Univ. Lille 1
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: fractal@ow2.org
 *
 * Author: Lionel Seinturier
 */

package org.objectweb.fractal.juliac.conf;


/**
 * The constants that can be used as aliases when specifying a module that needs
 * to be dynamically loaded by Juliac.
 * 
 * @author Lionel <Lionel.Seinturier@univ-lille1.fr>
 * @since 2.4
 */
public enum Module {

    JANINO("org.objectweb.fractal.juliac.compile.janino.CompileSupportImpl","org.ow2.fractal.juliac:juliac-janino"),
    JDT("org.objectweb.fractal.juliac.compile.jdt.CompileSupportImpl","org.ow2.fractal.juliac:juliac-jdt"),
    JDK6("org.objectweb.fractal.juliac.compile.jdk6.CompileSupportImpl","org.ow2.fractal.juliac:juliac-jdk6"),
    SPOON("org.objectweb.fractal.juliac.spoon.SpoonSupportImpl","org.ow2.fractal.juliac:juliac-spoon"),
    FRACTAL_ADL("org.objectweb.fractal.juliac.adl.FractalADLSupportImpl","org.ow2.fractal.juliac:juliac-fractaladl"),
    MIND_ADL("org.objectweb.fractal.juliac.mind.MindADLParserSupportImpl","org.ow2.fractal.juliac:juliac-mindadl"),
    OO("org.objectweb.fractal.juliac.opt.oo.FCOOCtrlSourceCodeGenerator","org.ow2.fractal.juliac:juliac-oo"),
    COMP("org.objectweb.fractal.juliac.opt.comp.FCCompCtrlSourceCodeGenerator","org.ow2.fractal.juliac:juliac-comp"),
    MERGE_ALL("org.objectweb.fractal.juliac.opt.mergeall.FCMergeAllSourceCodeGenerator","org.ow2.fractal.juliac:juliac-merge-all"),        
    ULTRA_COMP("org.objectweb.fractal.juliac.opt.ultracomp.FCUltraCompCtrlSourceCodeGenerator","org.ow2.fractal.juliac:juliac-ultra-comp-core");
    
    private Module( String className, String artifactDesc ) {
    	this.className = className;
    	this.artifactDesc = artifactDesc;
    }
    
    private String className;
    private String artifactDesc;
    
    public String getClassName() {
        return className;
    }
    
    public String getArtifactDesc() {
    	return artifactDesc;
    }
}
