/***
 * Juliac
 * Copyright (C) 2008-2012 Inria, Univ. Lille 1
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: fractal@ow2.org
 *
 * Author: Lionel Seinturier
 */

package org.objectweb.fractal.juliac.ucf;

import org.objectweb.fractal.juliac.api.RuntimeClassNotFoundException;

/**
 * Interface implemented by factories for {@link UnifiedClass}es.
 * 
 * @author Lionel Seinturier <Lionel.Seinturier@univ-lille1.fr>
 * @since 1.3
 */
public interface UnifiedClassFactoryItf {

    /**
     * Return a {@link UnifiedClass}.
     * 
     * @param name  the name of the requested {@link UnifiedClass}
     * @return      the corresponding {@link UnifiedClass}
     * @throws RuntimeClassNotFoundException
     *              if the {@link UnifiedClass} does not exist
     */
    public UnifiedClass create( String name )
	throws RuntimeClassNotFoundException;
}
